package kr.pe.okjsp;

import java.sql.*;
import DBHandler;
import kr.pe.okjsp.Member;
import ok.*;

public class MemberHandler {

	private Member member = new Member();
	
	private DBHandler db = new DBHandler();
	private String mydb="okjspdb";

	public MemberHandler() {}

	private String password = "";

// setters
	public void setId(String id) {
		member.setId(id);
	}

	public void setName(String name) {
		name = Kr.a2k(name);
		member.setName(name);
	}

	public void setRole(String role) {
		member.setRole(role);
	}

	public void setEmail(String email) {
		member.setEmail(email);
	}

	public void setPassword(String password) {
		this.password=password;
	}

// getters

	public Member getOne() {
		return this.member;
	}
	
	public boolean isIdExist() {
		boolean b_id_exist = true; // default true;
		
		if (member.getId()==null) return true;
		
		Connection pconn = db.getDbConnection(mydb);
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		String query = "select count(id) from member where lower(id)=lower(?)";
		
		try{
			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,member.getId());

			rs = pstmt.executeQuery();
			if(rs.next()) {
				int cnt = rs.getInt(1);
				if (cnt == 0) b_id_exist = false;
			}
			pstmt.close();
		}catch(Exception e){
			System.out.println("Member Handler isIdExist err:"+e.getMessage());
		} finally {
		db.freeDbConnection(mydb);
		} // end try catch
	
		return b_id_exist;
	}

	public boolean isEmailExist() {
		boolean b_email_exist = true; // default true;
		
		if (member.getEmail()==null) return true;
		
		Connection pconn = db.getDbConnection(mydb);
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		String query = "select count(email) from member where lower(email)=lower(?)";
		
		try{
			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,member.getEmail());

			rs = pstmt.executeQuery();
			if(rs.next()) {
				int cnt = rs.getInt(1);
				if (cnt == 0) b_email_exist = false;
			}
			
			pstmt.close();
		}catch(Exception e){
			System.out.println("Member Handler isEmailExist err:"+e.getMessage());
		} finally {
		db.freeDbConnection(mydb);
		} // end try catch
	
		return b_email_exist;
	}
	
	public int addMember() {
		if (isEmailExist()) return 2;
		
		Connection pconn = db.getDbConnection(mydb);
		PreparedStatement pstmt = null;

		String query = "insert into member (id, password, name, email) values (?, ?, ?, ?)";
		
		int insert_cnt = 0;
		
		try{
			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,member.getId());
			pstmt.setString(2,password);
			pstmt.setString(3,member.getName());
			pstmt.setString(4,member.getEmail());

			insert_cnt = pstmt.executeUpdate();
			pstmt.close();
		}catch(Exception e){
            System.out.println("DoRegister err:"+e.getMessage());
		} finally {
			db.freeDbConnection(mydb);
		} // end try catch
		
		return insert_cnt;
	}

	public int doLogin() {

		if (member.getId()==null) return 0;
		
		Connection pconn = db.getDbConnection(mydb);
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String query = "select * from member where id = ?";
		
		int sts = 0;
		String db_password = "";
		String db_name  = "";
		String db_email = "";
		String db_role  = "";
		
		try{
			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,member.getId());
			rs = pstmt.executeQuery();
			
			if(rs.next()) {
				db_password = Kr.nchk(rs.getString("password"));
				db_name     = rs.getString("name");
				db_email    = rs.getString("email");
				db_role     = rs.getString("role");
			}
			
			pstmt.close();
			
			if (db_password.equals(this.password)) {
				sts=1;
				member.setName(db_name);
				member.setEmail(db_email);
				member.setRole(db_role);
			} else {
				sts=2; // wrong password
			}
			
		}catch(Exception e){
            System.out.println("DoRegister err:"+e.getMessage());
		} finally {
			db.freeDbConnection(mydb);
		} // end try catch
		
		return sts;
	}
}
